# Entity Framework Core 3.0

Entity Framework (EF) Core est un ORM (Object-Relational Mapper) qui permet aux dveloppeurs .NET de grer de manire simple, lgre et extensible, des bases de donnes.
EF permet de grer de nombreux *providers* (SQL Server, SQLite, Cosmos, ...) de manire transparente.
EF vous permet galement de mettre  jour vos bases de donnes et d'excuter des requtes sans avoir  crire la moindre requte SQL. Vous pouvez passer par LINQ to SQL qui apportera plus de lisibilit et permettra au compilateur de vous aider  dtecter vos erreurs.
  
---
*Note:*  
Diffrentes solutions existent avec EF pour grer une base de donnes dont le modle existe par exemple. Dans ces exemples, je ne traiterai que la partie *Code First*, c'est--dire le cas o le modle est cr  partir de vos classes.
  
---
## Plan
Les exemples sont organiss selon le plan suivant:  
1. *Fundamentals* :  
Dans cette partie, je donnerai quelques notions pour se connecter  une base  l'aide de chane de connection (*connection strings*), comment utiliser des *providers de tests...*.
Il s'agira en consquence d'exemples simples manquants d'explications sur certains points, car ils seront prsents plus tard.
2. *Model* :  
Ce chapitre s'attardera sur le lien entre le modle et la base de donnes. En effet, avec EF, l'accs aux donnes se fait via le modle, c'est--dire l'ensemble de vos classes (qui seront relies  des tables cres plus ou moins automatiquement)
 ainsi qu'un contexte (```DbContext```) qui reprsentera une session de connexion avec votre (ou vos) base(s) de donnes.
   Je prsenterai en consquence tout d'abord comment crire des classes pour votre modle, puis comment crire les diffrentes relations classiques (aggrgation, *one to one*, *one to many*, *many to many*, mais aussi les dictionnaires), comment grer les hritages entre classes du modle dans la base de donnes, etc.
3. *Schemas and migrations* :
   Le but de ce chapitre sera de vous montrer comment garder votre modle et votre base de donnes synchroniss.
4. *Querying (LINQ to SQL) and saving data* :
   *Language INtegrated Query* (LINQ) est un outil de requte sur collections et sa version LINQ to SQL vous permet de passer trs facilement  un systme de requtes sur les bases de donnes.
Les requtes LINQ sont automatiquement traduites en requtes SQL, vous vitant ainsi d'avoir  crire vos requtes vous-mmes. Elles sont ds lors beaucoup plus lisibles et faciles  crire.
Ce chapitre prsente comment charger des donnes, raliser du filtrage, de manire synchrone ou asynchrone, etc.
   Il montre bien sr galement comment raliser le symtrique : mettre  jour, supprimer ou ajouter de nouvelles donnes dans la base.
5. *Database providers* :
   EF vous permet de grer votre base de donnes indpendamment du *provider*. Ce chapitre montrera donc comment utiliser diffrents providers parmi lesquels Microsoft SQL Server, SQLite ou encore InMemory dont le but est de permettre de tester la base en mmoire, sans passer par un *provider*.
   
---

## Quelle version utiliser ?
Ces exemples sont crits pour .NET Core 3.0, mais vous pouvez utiliser EF Core avec diffrents types projets. Voici les recommendations actuelles de Microsoft quant  l'utilisation des version d'EF.
   
|**EF Core**     |**1.x** |**2.x**    |**3.x**
|----------------|--------|-----------|---------------
|.NET Standard   |1.3     |2.0        |2.1
|.NET Core       |1.0     |2.0        |3.0
|.NET Framework  |4.5.1   |4.7.2      |(not supported)
|Mono            |4.6     |5.4        |6.4
|Xamarin.iOS     |10.0    |10.14      |12.16
|Xamarin.Android |7.0     |8.0        |10.0
|UWP             |10.0    |10.0.16299 |to be defined
|Unity           |2018.1  |2018.1     |to be defined

   *Comment lire ce tableau ?*
   
Si vous voulez utiliser EF Core 3.0 avec une bibliothque de classes crites en .NET Standard, celle-ci doit utiliser au moins .NET Standard 2.1.
   
Si vous voulez utiliser EF Core 3.0 avec un projet Xamarin.iOS, celui-ci doit tre au moins en version 12.16.
   
Si vous voulez utiliser EF Core dans une application UWP, vous ne pouvez pour le moment utiliser que EF Core 1.x ou 2.x.
  
---
   *Note :*
   
Je n'ai pas l'intention de mettre  jour les exemples pour Entity Framework 6 ou pour .NET Framework, puisque la version 5 du framework va unifier .NET Framework et .NET Core. En consquence, EF Core sera la nouvelle "norme".

   
